Index: /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/HeuristicLab.Hive.Contracts-3.3.csproj
===================================================================
--- /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/HeuristicLab.Hive.Contracts-3.3.csproj	(revision 4253)
+++ /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/HeuristicLab.Hive.Contracts-3.3.csproj	(revision 4254)
@@ -135,5 +135,4 @@
     <Compile Include="RecurrentEvent.cs" />
     <Compile Include="ResponseCalendar.cs" />
-    <Compile Include="ResponseSerializedJob.cs" />
     <Compile Include="MultiStream.cs" />
     <Compile Include="Interfaces\ISlaveFacade.cs" />
@@ -145,12 +144,10 @@
     <Compile Include="Interfaces\IServerConsoleFacade.cs" />
     <Compile Include="MessageContainer.cs" />
-    <Compile Include="ResponseJob.cs" />
     <Compile Include="HeuristicLabHiveContractsPlugin.cs" />
     <Compile Include="Interfaces\ISlaveCommunicator.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
     <Compile Include="Response.cs" />
-    <Compile Include="ResponseHB.cs" />
+    <Compile Include="ResponseHeartBeat.cs" />
     <Compile Include="ResponseList.cs" />
-    <Compile Include="ResponsePlugin.cs" />
     <Compile Include="ResponseResultReceived.cs" />
     <Compile Include="StreamedObject.cs" />
Index: /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/Interfaces/ISlaveCommunicator.cs
===================================================================
--- /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/Interfaces/ISlaveCommunicator.cs	(revision 4253)
+++ /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/Interfaces/ISlaveCommunicator.cs	(revision 4254)
@@ -34,33 +34,32 @@
   [ServiceContract]
   public interface ISlaveCommunicator {
+
     [OperationContract]
     Response Login(ClientDto clientInfo);
+
     [OperationContract]
-    ResponseHB ProcessHeartBeat(HeartBeatData hbData);
+    ResponseHeartBeat ProcessHeartBeat(HeartBeatData hbData);
+
     [OperationContract]
-    ResponseJob SendJob(Guid clientId);
-    //[OperationContract]
-    //ResponseSerializedJob SendSerializedJob(Guid clientId);
+    ResponseObject<JobDto> GetJob(Guid clientId);
+
     [OperationContract]
-    ResponseResultReceived StoreFinishedJobResult(Guid clientId, 
-      Guid jobId, 
-      byte[] result, 
-      double percentage,
-      string exception);
+    ResponseResultReceived StoreFinishedJobResult(Guid clientId, Guid jobId, byte[] result, double percentage, string exception);
+
     [OperationContract]
-    ResponseResultReceived ProcessSnapshot(Guid clientId,
-      Guid jobId, 
-      byte[] result, 
-      double percentage, 
-      string exception);
+    ResponseResultReceived ProcessSnapshot(Guid clientId, Guid jobId, byte[] result, double percentage, string exception);
+
     [OperationContract]
     Response Logout(Guid clientId);
+
     [OperationContract]
     Response IsJobStillNeeded(Guid jobId);
+
     [OperationContract]
-    ResponsePlugin SendPlugins(List<HivePluginInfoDto> pluginList);
+    ResponseList<CachedHivePluginInfoDto> SendPlugins(List<HivePluginInfoDto> pluginList);
 
     [OperationContract]
     ResponseCalendar GetCalendar(Guid clientId);
+
     [OperationContract]
     Response SetCalendarStatus(Guid clientId, CalendarState state);
Index: /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/MessageContainer.cs
===================================================================
--- /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/MessageContainer.cs	(revision 4253)
+++ /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/MessageContainer.cs	(revision 4254)
@@ -58,6 +58,6 @@
       MessageContainer clone = (MessageContainer)Activator.CreateInstance(this.GetType(), true);
       cloner.RegisterClonedObject(this, clone);
-      //clone.StatusMessage = this.StatusMessage;
-      //clone.Success = this.Success;
+      clone.Message = this.Message;
+      clone.JobId = this.JobId;
       return clone;
     }
Index: /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/ResponseHeartBeat.cs
===================================================================
--- /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/ResponseHeartBeat.cs	(revision 4254)
+++ /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/ResponseHeartBeat.cs	(revision 4254)
@@ -0,0 +1,50 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Runtime.Serialization;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Hive.Contracts {
+
+
+  /// <summary>
+  /// Response Heartbeat class
+  /// Return value to hearbeats sent by the client
+  /// </summary>
+  [StorableClass]
+  [DataContract]
+  public class ResponseHeartBeat : Response {
+    [Storable]
+    [DataMember]
+    public List<MessageContainer> ActionRequest { get; set; }
+
+    public override Common.IDeepCloneable Clone(Common.Cloner cloner) {
+      ResponseHeartBeat clone = (ResponseHeartBeat) base.Clone(cloner);
+      clone.ActionRequest = (from ar in this.ActionRequest
+                            select (MessageContainer) cloner.Clone(ar)).ToList();
+      return clone;
+    }
+  }
+}
Index: /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/ResponseObject.cs
===================================================================
--- /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/ResponseObject.cs	(revision 4253)
+++ /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/ResponseObject.cs	(revision 4254)
@@ -31,4 +31,5 @@
   [StorableClass]
   [DataContract]
+  [Serializable]
   public class ResponseObject<T> : Response
     where T : IDeepCloneable {
Index: /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/ResponsePlugin.cs
===================================================================
--- /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/ResponsePlugin.cs	(revision 4253)
+++ /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/ResponsePlugin.cs	(revision 4254)
@@ -11,5 +11,5 @@
   [DataContract]
   [Serializable]
-  public class ResponsePlugin : Response {
+  public class ResponsePlugin : ResponseBase {
     [Storable]
     [DataMember]
Index: /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/ResponseSerializedJob.cs
===================================================================
--- /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/ResponseSerializedJob.cs	(revision 4253)
+++ /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/ResponseSerializedJob.cs	(revision 4254)
@@ -37,5 +37,5 @@
   [DataContract]
   [Serializable]
-  public class ResponseSerializedJob : Response {
+  public class ResponseSerializedJob : ResponseBase {
     [Storable]
     [DataMember]
Index: /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/DefaultScheduler.cs
===================================================================
--- /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/DefaultScheduler.cs	(revision 4253)
+++ /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/DefaultScheduler.cs	(revision 4254)
@@ -13,45 +13,40 @@
 namespace HeuristicLab.Hive.Server.Core {
   internal class DefaultScheduler : IScheduler {
-    //private ISessionFactory factory;
 
-    private static Mutex jobLock =
-      new Mutex();
+    private static object jobLock = new object();
 
     #region IScheduler Members
 
-    public DefaultScheduler() {
-      //factory = ServiceLocator.GetSessionFactory();
-    }
+    public DefaultScheduler() { }
 
-    public bool ExistsJobForSlave(HeuristicLab.Hive.Contracts.BusinessObjects.HeartBeatData hbData) {
-      List<JobDto> allOfflineJobsForSlave =
-        new List<JobDto>(DaoLocator.JobDao.FindFittingJobsForSlave(State.Offline, hbData.FreeCores, hbData.FreeMemory, hbData.SlaveId));
+    public bool ExistsJobForSlave(HeartBeatData hbData) {
+      List<JobDto> allOfflineJobsForSlave = new List<JobDto>(DaoLocator.JobDao.FindFittingJobsForSlave(State.Offline, hbData.FreeCores, hbData.FreeMemory, hbData.SlaveId));
       return (allOfflineJobsForSlave != null && allOfflineJobsForSlave.Count > 0);
     }
 
-    public HeuristicLab.Hive.Contracts.BusinessObjects.JobDto GetNextJobForSlave(Guid slaveId) {
-      /// Critical section ///
-      jobLock.WaitOne();
-      JobDto jobToCalculate = null;
-      using (TransactionScope scope = new TransactionScope(TransactionScopeOption.Required, new TransactionOptions { IsolationLevel = ApplicationConstants.ISOLATION_LEVEL_SCOPE })) {
-        ClientDto slave = DaoLocator.ClientDao.FindById(slaveId);
-        LinkedList<JobDto> allOfflineJobsForSlave =
-          new LinkedList<JobDto>(DaoLocator.JobDao.FindFittingJobsForSlave(State.Offline, slave.NrOfFreeCores, slave.FreeMemory, slave.Id));        
-        if (allOfflineJobsForSlave != null && allOfflineJobsForSlave.Count > 0) {
-          jobToCalculate = allOfflineJobsForSlave.First.Value;
-          jobToCalculate.State = State.Calculating;
-          jobToCalculate.Client = slave;
-          jobToCalculate.Client.State = State.Calculating;
-          jobToCalculate.DateCalculated = DateTime.Now;
-          DaoLocator.JobDao.AssignSlaveToJob(slave.Id, jobToCalculate.Id);
-          DaoLocator.JobDao.Update(jobToCalculate);
-          DaoLocator.ClientDao.Update(jobToCalculate.Client);
+    public JobDto GetNextJobForSlave(Guid slaveId) {
+      lock (jobLock) {
+        /// Critical section ///
+        JobDto jobToCalculate = null;
+        using (TransactionScope scope = new TransactionScope(TransactionScopeOption.Required, new TransactionOptions { IsolationLevel = ApplicationConstants.ISOLATION_LEVEL_SCOPE })) {
+          ClientDto slave = DaoLocator.ClientDao.FindById(slaveId);
+          LinkedList<JobDto> allOfflineJobsForSlave =
+            new LinkedList<JobDto>(DaoLocator.JobDao.FindFittingJobsForSlave(State.Offline, slave.NrOfFreeCores, slave.FreeMemory, slave.Id));
+          if (allOfflineJobsForSlave != null && allOfflineJobsForSlave.Count > 0) {
+            jobToCalculate = allOfflineJobsForSlave.First.Value;
+            jobToCalculate.State = State.Calculating;
+            jobToCalculate.Client = slave;
+            jobToCalculate.Client.State = State.Calculating;
+            jobToCalculate.DateCalculated = DateTime.Now;
+            DaoLocator.JobDao.AssignSlaveToJob(slave.Id, jobToCalculate.Id);
+            DaoLocator.JobDao.Update(jobToCalculate);
+            DaoLocator.ClientDao.Update(jobToCalculate.Client);
+          }
+          scope.Complete();
         }
-        scope.Complete();
+        /// End Critical section ///
+
+        return jobToCalculate;
       }
-      jobLock.ReleaseMutex();
-      /// End Critical section ///
-
-      return jobToCalculate;
     }
 
Index: /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/Facades/SlaveFacade.cs
===================================================================
--- /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/Facades/SlaveFacade.cs	(revision 4253)
+++ /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/Facades/SlaveFacade.cs	(revision 4254)
@@ -55,5 +55,5 @@
     }
 
-    public ResponseHB ProcessHeartBeat(HeartBeatData hbData) {
+    public ResponseHeartBeat ProcessHeartBeat(HeartBeatData hbData) {
       using (contextFactory.GetContext()) {
         return slaveCommunicator.ProcessHeartBeat(hbData);
@@ -61,7 +61,7 @@
     }
 
-    public ResponseJob SendJob(Guid clientId) {
+    public ResponseObject<JobDto> GetJob(Guid clientId) {
       using (contextFactory.GetContext()) {
-        return slaveCommunicator.SendJob(clientId);
+        return slaveCommunicator.GetJob(clientId);
       }
     }
@@ -85,5 +85,5 @@
     }
 
-    public ResponsePlugin SendPlugins(List<HivePluginInfoDto> pluginList) {
+    public ResponseList<CachedHivePluginInfoDto> SendPlugins(List<HivePluginInfoDto> pluginList) {
       return slaveCommunicator.SendPlugins(pluginList);      
     }
@@ -118,10 +118,10 @@
         MultiStream stream = new MultiStream();
 
-        ResponseJob job = null;
+        ResponseObject<JobDto> job = null;
 
-        job = ServiceLocator.GetSlaveCommunicator().SendJob(clientId);
+        job = ServiceLocator.GetSlaveCommunicator().GetJob(clientId);
 
         //first send response
-        stream.AddStream(new StreamedObject<ResponseJob>(job));
+        stream.AddStream(new StreamedObject<ResponseObject<JobDto>>(job));
 
         IJobManager jobManager = ServiceLocator.GetJobManager();
@@ -130,6 +130,6 @@
         //second stream the job binary data
         MemoryStream memoryStream = new MemoryStream();
-        if (job.Job != null)
-          stream.AddStream(new MemoryStream(internalJobManager.GetSerializedJobDataById(job.Job.Id)));
+        if (job.Obj != null)
+          stream.AddStream(new MemoryStream(internalJobManager.GetSerializedJobDataById(job.Obj.Id)));
 
         OperationContext clientContext = OperationContext.Current;
@@ -145,5 +145,5 @@
 
     public Stream SendStreamedPlugins(List<HivePluginInfoDto> pluginList) {
-      return new StreamedObject<ResponsePlugin>(this.SendPlugins(pluginList));
+      return new StreamedObject<ResponseList<CachedHivePluginInfoDto>>(this.SendPlugins(pluginList));
     }
 
Index: /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/HeuristicLab.Hive.Server.Core-3.3.csproj
===================================================================
--- /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/HeuristicLab.Hive.Server.Core-3.3.csproj	(revision 4253)
+++ /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/HeuristicLab.Hive.Server.Core-3.3.csproj	(revision 4254)
@@ -125,5 +125,4 @@
     <Compile Include="Authorization\HivePermissionManager.cs" />
     <Compile Include="HeuristicLabHiveServerCorePlugin.cs" />
-    <Compile Include="HiveServerMessages.Designer.cs" />
     <Compile Include="InternalInterfaces\IHivePermissionManager.cs" />
     <Compile Include="InternalInterfaces\IInternalSlaveCommunicator.cs" />
Index: /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/JobManager.cs
===================================================================
--- /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/JobManager.cs	(revision 4253)
+++ /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/JobManager.cs	(revision 4254)
@@ -41,5 +41,4 @@
 namespace HeuristicLab.Hive.Server.Core {
   internal class JobManager : IJobManager, IInternalJobManager {
-    //ISessionFactory factory;
     private ILifecycleManager lifecycleManager;
 
@@ -47,9 +46,8 @@
 
     public JobManager() {
-      //factory = ServiceLocator.GetSessionFactory();
       lifecycleManager = ServiceLocator.GetLifecycleManager();
 
       lifecycleManager.RegisterStartup(new EventHandler(lifecycleManager_OnStartup));
-      lifecycleManager.RegisterStartup(new EventHandler(lifecycleManager_OnShutdown));
+      lifecycleManager.RegisterShutdown(new EventHandler(lifecycleManager_OnShutdown));
     }
 
@@ -61,15 +59,10 @@
       Logger.Info("Searching for dead Jobs");
 
-      // [chn] why is transaction management done here?
-      using (TransactionScope scope = new TransactionScope(TransactionScopeOption.Required, new TransactionOptions { IsolationLevel = ApplicationConstants.ISOLATION_LEVEL_SCOPE })) {
-        List<JobDto> allJobs = new List<JobDto>(DaoLocator.JobDao.FindAll());
-        foreach (JobDto curJob in allJobs) {
-          if (curJob.State != State.Calculating && curJob.State != State.Finished) {
-            DaoLocator.JobDao.SetJobOffline(curJob);
-          }
-        }
-        scope.Complete();
-      }
-      // DaoLocator.DestroyContext();
+      List<JobDto> allJobs = new List<JobDto>(DaoLocator.JobDao.FindAll());
+      foreach (JobDto curJob in allJobs) {
+        if (curJob.State != State.Calculating && curJob.State != State.Finished) {
+          DaoLocator.JobDao.SetJobOffline(curJob);
+        }
+      }
     }
 
@@ -322,4 +315,9 @@
     }
 
+    /// <summary>
+    /// Returns the current state for all jobs requested
+    /// </summary>
+    /// <param name="jobIds"></param>
+    /// <returns></returns>
     public ResponseObject<JobResultList> GetAllJobResults(IEnumerable<Guid> jobIds) {
       ResponseObject<JobResultList> response = new ResponseObject<JobResultList>();
@@ -334,5 +332,5 @@
           Exception = job.Exception,
           Percentage = job.Percentage
-        });        
+        });
       }
       response.Obj = jobResultList;
@@ -340,28 +338,4 @@
       response.StatusMessage = ApplicationConstants.RESPONSE_JOB_ALL_JOBS;
       return response;
-    }
-
-    public ResponseList<ProjectDto> GetAllProjects() {
-      return null;
-    }
-
-    private Response createUpdateProject(ProjectDto project) {
-      return null;
-    }
-
-    public Response CreateProject(ProjectDto project) {
-      return createUpdateProject(project);
-    }
-
-    public Response ChangeProject(ProjectDto project) {
-      return createUpdateProject(project);
-    }
-
-    public Response DeleteProject(Guid projectId) {
-      return null;
-    }
-
-    public ResponseList<JobDto> GetJobsByProject(Guid projectId) {
-      return null;
     }
 
@@ -376,4 +350,30 @@
     #endregion
 
+    #region Project handling (currently unimplemented)
+
+    public ResponseList<ProjectDto> GetAllProjects() {
+      throw new NotImplementedException();
+    }
+
+    private Response CreateUpdateProject(ProjectDto project) {
+      throw new NotImplementedException();
+    }
+
+    public Response CreateProject(ProjectDto project) {
+      return CreateUpdateProject(project);
+    }
+
+    public Response ChangeProject(ProjectDto project) {
+      return CreateUpdateProject(project);
+    }
+
+    public Response DeleteProject(Guid projectId) {
+      throw new NotImplementedException();
+    }
+
+    public ResponseList<JobDto> GetJobsByProject(Guid projectId) {
+      throw new NotImplementedException();
+    }
+    #endregion
   }
 }
Index: /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/ServiceLocator.cs
===================================================================
--- /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/ServiceLocator.cs	(revision 4253)
+++ /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/ServiceLocator.cs	(revision 4254)
@@ -97,5 +97,5 @@
     public static ILifecycleManager GetLifecycleManager() {
       if (lifecycleManager == null) {
-        lifecycleManager = new LifecycleManager();
+        lifecycleManager = ApplicationManager.Manager.GetInstances<ILifecycleManager>().First();
       }
       return lifecycleManager;
Index: /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/SlaveCommunicator.cs
===================================================================
--- /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/SlaveCommunicator.cs	(revision 4253)
+++ /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/SlaveCommunicator.cs	(revision 4254)
@@ -248,8 +248,8 @@
     /// <param name="hbData"></param>
     /// <returns></returns>
-    public ResponseHB ProcessHeartBeat(HeartBeatData hbData) {
+    public ResponseHeartBeat ProcessHeartBeat(HeartBeatData hbData) {
       Logger.Debug("BEGIN Processing Heartbeat for Client " + hbData.SlaveId);
 
-      ResponseHB response = new ResponseHB();
+      ResponseHeartBeat response = new ResponseHeartBeat();
       response.ActionRequest = new List<MessageContainer>();
 
@@ -342,5 +342,5 @@
     /// <param name="clientAdapter"></param>
     /// <param name="response"></param>
-    private void ProcessJobProcess(HeartBeatData hbData, ResponseHB response) {
+    private void ProcessJobProcess(HeartBeatData hbData, ResponseHeartBeat response) {
       Logger.Debug("Started for Client " + hbData.SlaveId);
       List<JobDto> jobsOfClient = new List<JobDto>(DaoLocator.JobDao.FindActiveJobsOfSlave(DaoLocator.ClientDao.FindById(hbData.SlaveId)));
@@ -432,12 +432,11 @@
     /// <param name="clientId"></param>
     /// <returns></returns>
-    public ResponseJob SendJob(Guid clientId) {
-
-      ResponseJob response = new ResponseJob();
+    public ResponseObject<JobDto> GetJob(Guid clientId) {
+      ResponseObject<JobDto> response = new ResponseObject<JobDto>();
 
       JobDto job2Calculate = scheduler.GetNextJobForSlave(clientId);
       if (job2Calculate != null) {
-        response.Job = job2Calculate;
-        response.Job.PluginsNeeded = DaoLocator.PluginInfoDao.GetPluginDependenciesForJob(response.Job);
+        response.Obj = job2Calculate;
+        response.Obj.PluginsNeeded = DaoLocator.PluginInfoDao.GetPluginDependenciesForJob(response.Obj);
         response.Success = true;
         Logger.Info("Job pulled: " + job2Calculate + " for user " + clientId);
@@ -449,11 +448,8 @@
       } else {
         response.Success = false;
-        response.Job = null;
+        response.Obj = null;
         response.StatusMessage = ApplicationConstants.RESPONSE_COMMUNICATOR_NO_JOBS_LEFT;
         Logger.Info("No more Jobs left for " + clientId);
       }
-
-
-
       return response;
     }
@@ -711,6 +707,6 @@
     }
 
-    public ResponsePlugin SendPlugins(List<HivePluginInfoDto> pluginList) {
-      ResponsePlugin response = new ResponsePlugin();
+    public ResponseList<CachedHivePluginInfoDto> SendPlugins(List<HivePluginInfoDto> pluginList) {
+      ResponseList<CachedHivePluginInfoDto> response = new ResponseList<CachedHivePluginInfoDto>();
       foreach (HivePluginInfoDto pluginInfo in pluginList) {
         if (pluginInfo.Update) {
@@ -719,5 +715,5 @@
             ApplicationManager.Manager.Plugins.Where(pd => pd.Name == pluginInfo.Name && pd.Version.Major == pluginInfo.Version.Major && pd.Version.Minor == pluginInfo.Version.Minor && pd.Version.Revision > pluginInfo.Version.Revision).SingleOrDefault();
           if (ipd != null) {
-            response.Plugins.Add(convertPluginDescriptorToDto(ipd));
+            response.List.Add(convertPluginDescriptorToDto(ipd));
           }
         } else {
@@ -725,5 +721,5 @@
             ApplicationManager.Manager.Plugins.Where(pd => pd.Name == pluginInfo.Name && pd.Version.Major == pluginInfo.Version.Major && pd.Version.Minor == pluginInfo.Version.Minor && pd.Version.Revision >= pluginInfo.Version.Revision).SingleOrDefault();
           if (ipd != null) {
-            response.Plugins.Add(convertPluginDescriptorToDto(ipd));
+            response.List.Add(convertPluginDescriptorToDto(ipd));
           } else {
             response.Success = false;
Index: /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server/3.3/HeuristicLab.Hive.Server-3.3.csproj
===================================================================
--- /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server/3.3/HeuristicLab.Hive.Server-3.3.csproj	(revision 4253)
+++ /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server/3.3/HeuristicLab.Hive.Server-3.3.csproj	(revision 4254)
@@ -78,4 +78,7 @@
   </PropertyGroup>
   <ItemGroup>
+    <Reference Include="HeuristicLab.Common.Resources-3.3">
+      <HintPath>..\..\..\..\..\..\..\..\..\Programme\HeuristicLab 3.3\HeuristicLab.Common.Resources-3.3.dll</HintPath>
+    </Reference>
     <Reference Include="HeuristicLab.PluginInfrastructure-3.3">
       <HintPath>..\..\..\..\..\..\..\..\..\Programme\HeuristicLab 3.3\HeuristicLab.PluginInfrastructure-3.3.dll</HintPath>
@@ -133,25 +136,6 @@
       <SubType>Designer</SubType>
     </EmbeddedResource>
-    <EmbeddedResource Include="Properties\Resources.resx">
-      <Generator>ResXFileCodeGenerator</Generator>
-      <LastGenOutput>Resources.Designer.cs</LastGenOutput>
-      <SubType>Designer</SubType>
-    </EmbeddedResource>
-    <Compile Include="Properties\Resources.Designer.cs">
-      <AutoGen>True</AutoGen>
-      <DependentUpon>Resources.resx</DependentUpon>
-      <DesignTime>True</DesignTime>
-    </Compile>
     <None Include="Properties\AssemblyInfo.frame" />
     <None Include="HeuristicLab.snk" />
-    <None Include="Properties\Settings.settings">
-      <Generator>SettingsSingleFileGenerator</Generator>
-      <LastGenOutput>Settings.Designer.cs</LastGenOutput>
-    </None>
-    <Compile Include="Properties\Settings.Designer.cs">
-      <AutoGen>True</AutoGen>
-      <DependentUpon>Settings.settings</DependentUpon>
-      <DesignTimeSharedInput>True</DesignTimeSharedInput>
-    </Compile>
   </ItemGroup>
   <ItemGroup>
@@ -164,7 +148,4 @@
       <Name>HeuristicLab.Hive.Server.Core-3.3</Name>
     </ProjectReference>
-  </ItemGroup>
-  <ItemGroup>
-    <None Include="Resources\HeuristicLab.ico" />
   </ItemGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
Index: /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server/3.3/HeuristicLabHiveServerApplication.cs
===================================================================
--- /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server/3.3/HeuristicLabHiveServerApplication.cs	(revision 4253)
+++ /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server/3.3/HeuristicLabHiveServerApplication.cs	(revision 4254)
@@ -30,4 +30,5 @@
 using HeuristicLab.Hive.Contracts.Interfaces;
 using HeuristicLab.PluginInfrastructure;
+using HeuristicLab.Hive.Server.Core;
 
 namespace HeuristicLab.Hive.Server {
@@ -162,17 +163,13 @@
       baseAddrDict.Add(STR_ExecutionEngineFacade, StartService(Services.ExecutionEngineFacade, addresses[index], WcfSettings.DEFAULTPORT));
 
-      // [chn] why is lifecyclemanager instantiated here?? shouldnt Core.ServiceLocator be used?
-      IEnumerable<ILifecycleManager> lifecycleManagers = ApplicationManager.Manager.GetInstances<ILifecycleManager>();
-      if (lifecycleManagers.Count() > 0) {
-        ILifecycleManager lifecycleManager = lifecycleManagers.First();
+      ILifecycleManager lifecycleManager = ServiceLocator.GetLifecycleManager();
 
-        lifecycleManager.Init();
+      lifecycleManager.Init();
 
-        // [chn] remove gui code here, how to display any response from server?
-        Form mainForm = new MainForm(baseAddrDict);
-        Application.Run(mainForm);
+      Form mainForm = new MainForm(baseAddrDict);
+      Application.Run();
 
-        lifecycleManager.Shutdown();
-      }
+      lifecycleManager.Shutdown();
+      
       StopService(Services.All);
     }
Index: /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server/3.3/HeuristicLabHiveServerPlugin.cs
===================================================================
--- /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server/3.3/HeuristicLabHiveServerPlugin.cs	(revision 4253)
+++ /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server/3.3/HeuristicLabHiveServerPlugin.cs	(revision 4254)
@@ -29,4 +29,5 @@
   [Plugin("HeuristicLab.Hive.Server", "3.3")]
   [PluginFile("HeuristicLab.Hive.Server-3.3.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Common.Resources", "3.3")]
   [PluginDependency("HeuristicLab.Hive.Contracts", "3.3")]
   [PluginDependency("HeuristicLab.Hive.Server.Core", "3.3")]
Index: /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server/3.3/MainForm.Designer.cs
===================================================================
--- /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server/3.3/MainForm.Designer.cs	(revision 4253)
+++ /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server/3.3/MainForm.Designer.cs	(revision 4254)
@@ -51,8 +51,11 @@
           // rtfServices
           // 
+          this.rtfServices.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+                      | System.Windows.Forms.AnchorStyles.Left)
+                      | System.Windows.Forms.AnchorStyles.Right)));
           this.rtfServices.Location = new System.Drawing.Point(12, 25);
           this.rtfServices.Name = "rtfServices";
           this.rtfServices.ReadOnly = true;
-          this.rtfServices.Size = new System.Drawing.Size(280, 121);
+          this.rtfServices.Size = new System.Drawing.Size(377, 129);
           this.rtfServices.TabIndex = 1;
           this.rtfServices.Text = "";
@@ -96,10 +99,8 @@
           this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
           this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
-          this.ClientSize = new System.Drawing.Size(304, 166);
+          this.ClientSize = new System.Drawing.Size(401, 166);
           this.Controls.Add(this.rtfServices);
           this.Controls.Add(this.label1);
-          this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
           this.Name = "MainForm";
-          this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
           this.Text = "Hive Server";
           this.FormClosing += new System.Windows.Forms.FormClosingEventHandler(this.MainForm_FormClosing);
